<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>[[//TOC//]]</title>
<meta name="generator" content="https://txt2tags.org">
<meta name="viewport" content="width=device-width, initial-scale=1" />
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
<h1>[[//TOC//]]</h1>
</hgroup>
</header>


<div class="body">

<section>
<h1>Synergy agora é DeskFlow</h1>

<p>
<strong><em>Colaboração: Paulo Roberto Bagatini</em></strong>
</p>
<p>
<strong><em>Data de Publicação:</em></strong>
</p>

<section>
<h2>Compilação</h2>

<pre class="comandos">
<span class="saida">mkdir -p /export/src/git/github.com</span>
<span class="saida">cd /export/src/git/github.com</span>

<span class="saida">podman rm  -ft0 build</span>
<span class="saida">podman run -di -v $PWD:/src -w /src --name build ubuntu:24.04</span>
<span class="saida">podman exec -ti build bash</span>

<span class="saida">export DEBIAN_FRONTEND=noninteractive</span>

<span class="saida">apt update</span>
<span class="saida">apt install -y git{,-lfs} python3</span>

<span class="saida">[[ -d deskflow ]] || time git clone http://github.com/deskflow/deskflow # 0m12.370s 109M</span>

<span class="saida">cd deskflow</span>

<span class="saida">time scripts/install_deps.py # 6m55.636s 167M</span>
<span class="saida"># Run-time dependency cli11 found: NO (tried pkgconfig and cmake)</span>

<span class="saida">rm -r build</span>
<span class="saida">time cmake -B build --preset=linux-release # 0m7.964s</span>
<span class="saida"># libei     &gt;= 1.3 not found</span>
<span class="saida"># libportal &gt;= 0.8 not found</span>

<span class="saida">time cmake --build build -j8 # 2m58.529s 210M</span>
<span class="saida">exit</span>

<span class="saida">time ./build/bin/unittests   # 0m1,281s</span>

<span class="saida">sudo apt install -y libqt6dbus6t64 libqt6widgets6t64 libxkbfile1 libnotify4</span>

<span class="saida">cd build/bin</span>
<span class="saida">du -chs # 12M</span>
<span class="saida">strip *</span>
<span class="saida">du -chs # 8,9M</span>
<span class="saida">./deskflow-server --version | head -n1 # deskflow-server v1.18.0, protocol v1.8</span>
<span class="saida">./deskflow-server --help</span>
<span class="saida">./deskflow-client --help</span>
<span class="saida">./deskflow</span>

<span class="saida">ver=$(./deskflow-server --version | grep -oP 'v\K[^ ]+(?=,)')</span>

<span class="saida">sudo chown -R $USER: /export/app</span>
<span class="saida">mkdir -p    /export/app/deskflow/$ver</span>
<span class="saida">cp -a desk* /export/app/deskflow/$ver</span>
<span class="saida">ln -s $ver  /export/app/deskflow/default</span>
<span class="saida">ln -s       /export/app/deskflow/default/deskflow{,-server,-client} /fs/bin</span>
<span class="saida">ls -la /fs/bin/deskflow*</span>
</pre>

</section>
<section>
<h2>Atalho para o aplicativo gráfico</h2>

<pre class="comandos">
<span class="saida">curl -s https://raw.githubusercontent.com/deskflow/deskflow-artwork/refs/heads/main/icon/deskflow-icon-pad.svg &gt; /fs/share/icons/deskflow.svg</span>

<span class="saida"># cat &lt;&lt; EOT | sudo tee /usr/share/applications/deskflow.desktop</span>
<span class="saida">  cat &lt;&lt; EOT &gt; /fs/share/applications/deskflow.desktop</span>
<span class="saida">[Desktop Entry]</span>
<span class="saida">Version=1.0</span>
<span class="saida">Name=DeskFlow</span>
<span class="saida">Exec=/fs/bin/deskflow</span>
<span class="saida">Terminal=false</span>
<span class="saida">X-MultipleArgs=false</span>
<span class="saida">Type=Application</span>
<span class="saida">Icon=/fs/share/icons/deskflow.svg</span>
<span class="saida">Categories=Network;</span>
<span class="saida">StartupNotify=true</span>
<span class="saida">EOT</span>
</pre>

</section>
<section>
<h2>Servidor (XUbuntu 24.04)</h2>

<p>
Arquivo de configuração:
</p>

<pre class="comandos">
<span class="saida"> server=server</span>
<span class="saida">lclient=lclient</span>
<span class="saida">rclient=rclient</span>

<span class="saida">cat &lt;&lt; EOT &gt; /fs/etc/deskflow.conf</span>
<span class="saida">section: screens</span>
<span class="saida">  $lclient:</span>
<span class="saida">  $server:</span>
<span class="saida">  $rclient:</span>
<span class="saida">end</span>
<span class="saida">section: links</span>
<span class="saida">  $lclient:</span>
<span class="saida">    right = $server</span>
<span class="saida">  $server:</span>
<span class="saida">    left  = $lclient</span>
<span class="saida">    right = $rclient</span>
<span class="saida">  $rclient:</span>
<span class="saida">    left  = $server</span>
<span class="saida">end</span>
<span class="saida">EOT</span>

<span class="saida">deskflow-server -c /fs/etc/deskflow.conf</span>
</pre>

<p>
Defaults do arquivo de configuração:
</p>

<pre class="comandos">
<span class="saida">section: screens</span>
<span class="saida">  $host:</span>
<span class="saida">    halfDuplexCapsLock     = false</span>
<span class="saida">    halfDuplexNumLock      = false</span>
<span class="saida">    halfDuplexScrollLock   = false</span>
<span class="saida">    xtestIsXineramaUnaware = false</span>
<span class="saida">    switchCorners          = none</span>
<span class="saida">    switchCornerSize       = 0</span>
<span class="saida">end</span>

<span class="saida">section: links</span>
<span class="saida">end</span>

<span class="saida">section: aliases</span>
<span class="saida">end</span>

<span class="saida">section: options</span>
<span class="saida">  relativeMouseMoves   = false</span>
<span class="saida">  win32KeepForeground  = false</span>
<span class="saida">  disableLockToScreen  = false</span>
<span class="saida">  clipboardSharing     = true</span>
<span class="saida">  clipboardSharingSize = 3072</span>
<span class="saida">  switchCorners        = none</span>
<span class="saida">  switchCornerSize     = 0</span>
<span class="saida">end</span>
</pre>

<p>
Certificado:
</p>

<pre class="comandos">
<span class="saida">pem=/fs/etc/deskflow.pem</span>

<span class="saida">openssl req -nodes -newkey rsa:2048 -x509 -subj /CN=Deskflow -days 365 -keyout - -out - 2&gt;&amp;amp;- &gt; $pem</span>

<span class="saida">openssl x509 -in $pem -noout -text</span>
<span class="saida"># Certificate:</span>
<span class="saida">#     Data:</span>
<span class="saida">#         Version: 3 (0x2)</span>
<span class="saida">#         Serial Number:</span>
<span class="saida">#             05:62:af:27:1a:91:b2:1f:da:26:3e:6e:95:d2:f2:67:33:00:d2:df</span>
<span class="saida">#         Signature Algorithm: sha256WithRSAEncryption</span>
<span class="saida">#         Issuer: CN = Deskflow</span>
<span class="saida">#         Validity</span>
<span class="saida">#             Not Before: Oct  5 05:05:26 2024 GMT</span>
<span class="saida">#             Not After : Oct  5 05:05:26 2025 GMT</span>
<span class="saida">#         Subject: CN = Deskflow</span>
<span class="saida">#         Subject Public Key Info:</span>
<span class="saida">#             Public Key Algorithm: rsaEncryption</span>
<span class="saida">#                 Public-Key: (2048 bit)</span>

<span class="saida">openssl x509 -in $pem -noout -fingerprint -sha256 | cut -d= -f2 &gt; ${pem%.*}.fp</span>
<span class="saida"># 1E:2F:27:86:73:1B:BF:CE:E6:94:8A:06:B2:AE:5E:EA:CB:1E:CD:3B:57:84:58:49:47:D5:11:16:D4:72:54:EB</span>
</pre>

<p>
Executar o servidor na tela de login:
</p>

<pre class="comandos">
<span class="saida">cat &lt;&lt; EOT | sudo tee /etc/lightdm/lightdm.conf</span>
<span class="saida">[Seat:*]</span>
<span class="saida">autologin-user=</span>

<span class="saida">[SeatDefaults]</span>
<span class="saida">greeter-setup-script=/fs/bin/deskflow-server -n server -c /fs/etc/deskflow.conf --enable-crypto --tls-cert /fs/etc/deskflow.pem</span>
<span class="saida">EOT</span>

<span class="saida">sudo systemctl restart lightdm</span>

<span class="saida">ps -ef | grep [d]eskflow</span>
</pre>

</section>
<section>
<h2>Cliente (Ubuntu 24.04)</h2>

<p>
Forçar a tela de login a usar o Xorg:
</p>

<pre class="comandos">
<span class="saida">sudo sed -r 's/.*(WaylandEnable=).*/\1false/' /etc/gdm3/custom.conf</span>
</pre>

<p>
Colocar a fingerprint do certificado no homes dos usuários <code>gdm</code> e <code>root</code>:
</p>

<pre class="comandos">
<span class="saida">for i in root gdm</span>
<span class="saida">{</span>
<span class="saida">  eval sudo mkdir -p ~$i/.deskflow/SSL/Fingerprints</span>
<span class="saida">  eval sudo ln -fs /fs/etc/deskflow.fp ~$i/.deskflow/SSL/Fingerprints/TrustedServers.txt</span>
<span class="saida">  eval sudo chown -R $i: ~$i/.deskflow</span>
<span class="saida">}</span>
</pre>

<p>
Criar um script que inicia o cliente deskflow apropriadamente conforme o usuário:
</p>

<pre class="comandos">
<span class="saida">cat &lt;&lt; \EOT &gt; /fs/bin/deskflow-client.sh</span>
<span class="saida">#!/bin/bash</span>

<span class="saida">  server=192.168.0.102</span>

<span class="saida">  if [[ $USER != gdm ]]</span>
<span class="saida">  then</span>
<span class="saida">    export    DISPLAY=:1</span>
<span class="saida">    export XAUTHORITY=/run/user/$(id -u $USER)/gdm/Xauthority</span>
<span class="saida">    killall deskflow-client</span>
<span class="saida">  fi</span>

<span class="saida"># declare -p &gt; /tmp/env-$USER</span>

<span class="saida">  /fs/bin/deskflow-client -n rclient --sync-language --enable-crypto $server</span>

<span class="saida">EOT</span>

<span class="saida">chmod +x /fs/bin/deskflow-client.sh</span>
</pre>

<p>
Executar o script do cliente na tela de login:
</p>

<pre class="comandos">
<span class="saida"># cat &lt;&lt; EOT | sudo tee /usr/share/gdm/greeter/autostart/deskflow-client.desktop</span>
<span class="saida">  cat &lt;&lt; EOT &gt; /fs/share/applications/deskflow-client.desktop</span>
<span class="saida">[Desktop Entry]</span>
<span class="saida">Type=Application</span>
<span class="saida">Name=DeskFlow Client</span>
<span class="saida">Exec=/fs/bin/deskflow-client.sh</span>
<span class="saida">X-GNOME-AutoRestart=true</span>
<span class="saida">EOT</span>

<span class="saida">sudo ln -fs /fs/share/applications/deskflow-client.desktop /usr/share/gdm/greeter/autostart/deskflow-client.desktop</span>
</pre>

<p>
Executar o script do cliente na sessão do usuário logado (após o login no Ubuntu, haverá um certo delay até a conexão se reestabelecer):
</p>

<pre class="comandos">
<span class="saida"># cat &lt;&lt; EOT | sudo tee /etc/gdm3/PostLogin/Default</span>
<span class="saida">  cat &lt;&lt; EOT &gt;       /fs/etc/gdm3/PostLogin/Default</span>
<span class="saida">#!/bin/bash</span>
<span class="saida">/fs/bin/deskflow-client.sh</span>
<span class="saida">EOT</span>

<span class="saida">chmod +x    /fs/etc/gdm3/PostLogin/Default</span>
<span class="saida">sudo ln -fs /fs/etc/gdm3/PostLogin/Default /etc/gdm3/PostLogin/Default</span>
</pre>

<p>
Reiniciar o GDM:
</p>

<pre class="comandos">
<span class="saida">sudo systemctl restart gdm</span>
<span class="saida">ps -ef | grep [d]eskflow</span>
</pre>

</section>
<section>
<h2>Resolução de problemas</h2>

<p>
Tanto no servidor quanto nos clientes, o <code>syslog</code> pode ser analizado para resolver eventuais problemas de conexão:
</p>

<pre class="comandos">
<span class="saida">sudo tail -f /var/log/syslog | grep -i deskflow</span>
</pre>

</section>
<section>
<h2>Referências</h2>

 <ul>
 <li><a href="http://github.com/deskflow/deskflow/tree/v2-dev">http://github.com/deskflow/deskflow/tree/v2-dev</a>
 </li>
 <li><a href="http://github.com/deskflow/deskflow/wiki/Getting-Started">http://github.com/deskflow/deskflow/wiki/Getting-Started</a>
 </li>
 <li><a href="http://github.com/deskflow/deskflow/wiki/Compiling#ubuntu-1604-and-up">http://github.com/deskflow/deskflow/wiki/Compiling#ubuntu-1604-and-up</a>
 </li>
 <li><a href="http://github.com/deskflow/deskflow/wiki/Compiling#Linux">http://github.com/deskflow/deskflow/wiki/Compiling#Linux</a>
 </li>
 <li><a href="http://digitalocean.com/community/tutorials/openssl-essentials-working-with-ssl-certificates-private-keys-and-csrs">http://digitalocean.com/community/tutorials/openssl-essentials-working-with-ssl-certificates-private-keys-and-csrs</a>
 </li>
 </ul>

</section>
<section>
<h2>Comandos usados nesse artigo</h2>

 <ul>
 <li><a href="http://man.archlinux.org/man/bash.1">bash</a>: <a href="http://man.archlinux.org/man/bash.1#cd">cd</a>, <a href="http://man.archlinux.org/man/bash.1#declare">declare</a>, <a href="http://man.archlinux.org/man/bash.1#eval">eval</a>, <a href="http://man.archlinux.org/man/bash.1#exit">exit</a>, <a href="http://man.archlinux.org/man/bash.1#export">export</a>, <a href="http://man.archlinux.org/man/bash.1#for">for</a>, <a href="http://man.archlinux.org/man/bash.1#if">if</a>, <a href="http://man.archlinux.org/man/bash.1#test">test</a>, <a href="http://man.archlinux.org/man/bash.1#Pipelines">time</a>
 </li>
 <li><a href="http://man.archlinux.org/man/apt.8">apt</a>
 </li>
 <li><a href="http://man.archlinux.org/man/cat.1">cat</a>
 </li>
 <li><a href="http://man.archlinux.org/man/chmod.1">chmod</a>
 </li>
 <li><a href="http://man.archlinux.org/man/chown.1">chown</a>
 </li>
 <li><a href="http://man.archlinux.org/man/cmake.1">cmake</a>
 </li>
 <li><a href="http://man.archlinux.org/man/cp.1">cp</a>
 </li>
 <li><a href="http://man.archlinux.org/man/curl.1">curl</a>
 </li>
 <li><a href="http://man.archlinux.org/man/cut.1">cut</a>
 </li>
 <li><a href="http://man.archlinux.org/man/git.1">git</a>
 </li>
 <li><a href="http://man.archlinux.org/man/grep.1">grep</a>
 </li>
 <li><a href="http://man.archlinux.org/man/killall.1">killall</a>
 </li>
 <li><a href="http://man.archlinux.org/man/ln.1">ln</a>
 </li>
 <li><a href="http://man.archlinux.org/man/ls.1">ls</a>
 </li>
 <li><a href="http://man.archlinux.org/man/mkdir.1">mkdir</a>
 </li>
 <li><a href="http://man.archlinux.org/man/openssl.1">openssl</a>
 </li>
 <li><a href="http://man.archlinux.org/man/podman.1">podman</a>
 </li>
 <li><a href="http://man.archlinux.org/man/ps.1">ps</a>
 </li>
 <li><a href="http://man.archlinux.org/man/rm.1">rm</a>
 </li>
 <li><a href="http://man.archlinux.org/man/sed.1">sed</a>
 </li>
 <li><a href="http://man.archlinux.org/man/sudo.8">sudo</a>
 </li>
 <li><a href="http://man.archlinux.org/man/systemctl.1">systemctl</a>
 </li>
 <li><a href="http://man.archlinux.org/man/tail.1">tail</a>
 </li>
 <li><a href="http://man.archlinux.org/man/tee.1">tee</a>
 </li>
 </ul>

</section>
</section>
</div>
</body></html>
